git-am.shon commit Merge branch 'jn/test-lint-unmoor' (3784ba3)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005, 2006 Junio C Hamano
   4
   5SUBDIRECTORY_OK=Yes
   6OPTIONS_KEEPDASHDASH=
   7OPTIONS_STUCKLONG=t
   8OPTIONS_SPEC="\
   9git am [options] [(<mbox>|<Maildir>)...]
  10git am [options] (--continue | --skip | --abort)
  11--
  12i,interactive   run interactively
  13b,binary*       (historical option -- no-op)
  143,3way          allow fall back on 3way merging if needed
  15q,quiet         be quiet
  16s,signoff       add a Signed-off-by line to the commit message
  17u,utf8          recode into utf8 (default)
  18k,keep          pass -k flag to git-mailinfo
  19keep-non-patch  pass -b flag to git-mailinfo
  20keep-cr         pass --keep-cr flag to git-mailsplit for mbox format
  21no-keep-cr      do not pass --keep-cr flag to git-mailsplit independent of am.keepcr
  22c,scissors      strip everything before a scissors line
  23whitespace=     pass it through git-apply
  24ignore-space-change pass it through git-apply
  25ignore-whitespace pass it through git-apply
  26directory=      pass it through git-apply
  27exclude=        pass it through git-apply
  28include=        pass it through git-apply
  29C=              pass it through git-apply
  30p=              pass it through git-apply
  31patch-format=   format the patch(es) are in
  32reject          pass it through git-apply
  33resolvemsg=     override error message when patch failure occurs
  34continue        continue applying patches after resolving a conflict
  35r,resolved      synonyms for --continue
  36skip            skip the current patch
  37abort           restore the original branch and abort the patching operation.
  38committer-date-is-author-date    lie about committer date
  39ignore-date     use current timestamp for author date
  40rerere-autoupdate update the index with reused conflict resolution if possible
  41S,gpg-sign?     GPG-sign commits
  42rebasing*       (internal use for git-rebase)"
  43
  44. git-sh-setup
  45. git-sh-i18n
  46prefix=$(git rev-parse --show-prefix)
  47set_reflog_action am
  48require_work_tree
  49cd_to_toplevel
  50
  51git var GIT_COMMITTER_IDENT >/dev/null ||
  52        die "$(gettext "You need to set your committer info first")"
  53
  54if git rev-parse --verify -q HEAD >/dev/null
  55then
  56        HAS_HEAD=yes
  57else
  58        HAS_HEAD=
  59fi
  60
  61cmdline="git am"
  62if test '' != "$interactive"
  63then
  64        cmdline="$cmdline -i"
  65fi
  66if test '' != "$threeway"
  67then
  68        cmdline="$cmdline -3"
  69fi
  70
  71sq () {
  72        git rev-parse --sq-quote "$@"
  73}
  74
  75stop_here () {
  76    echo "$1" >"$dotest/next"
  77    git rev-parse --verify -q HEAD >"$dotest/abort-safety"
  78    exit 1
  79}
  80
  81safe_to_abort () {
  82        if test -f "$dotest/dirtyindex"
  83        then
  84                return 1
  85        fi
  86
  87        if ! test -s "$dotest/abort-safety"
  88        then
  89                return 0
  90        fi
  91
  92        abort_safety=$(cat "$dotest/abort-safety")
  93        if test "z$(git rev-parse --verify -q HEAD)" = "z$abort_safety"
  94        then
  95                return 0
  96        fi
  97        gettextln "You seem to have moved HEAD since the last 'am' failure.
  98Not rewinding to ORIG_HEAD" >&2
  99        return 1
 100}
 101
 102stop_here_user_resolve () {
 103    if [ -n "$resolvemsg" ]; then
 104            printf '%s\n' "$resolvemsg"
 105            stop_here $1
 106    fi
 107    eval_gettextln "When you have resolved this problem, run \"\$cmdline --continue\".
 108If you prefer to skip this patch, run \"\$cmdline --skip\" instead.
 109To restore the original branch and stop patching, run \"\$cmdline --abort\"."
 110
 111    stop_here $1
 112}
 113
 114go_next () {
 115        rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
 116                "$dotest/patch" "$dotest/info"
 117        echo "$next" >"$dotest/next"
 118        this=$next
 119}
 120
 121cannot_fallback () {
 122        echo "$1"
 123        gettextln "Cannot fall back to three-way merge."
 124        exit 1
 125}
 126
 127fall_back_3way () {
 128    O_OBJECT=$(cd "$GIT_OBJECT_DIRECTORY" && pwd)
 129
 130    rm -fr "$dotest"/patch-merge-*
 131    mkdir "$dotest/patch-merge-tmp-dir"
 132
 133    # First see if the patch records the index info that we can use.
 134    cmd="git apply $git_apply_opt --build-fake-ancestor" &&
 135    cmd="$cmd "'"$dotest/patch-merge-tmp-index" "$dotest/patch"' &&
 136    eval "$cmd" &&
 137    GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
 138    git write-tree >"$dotest/patch-merge-base+" ||
 139    cannot_fallback "$(gettext "Repository lacks necessary blobs to fall back on 3-way merge.")"
 140
 141    say "$(gettext "Using index info to reconstruct a base tree...")"
 142
 143    cmd='GIT_INDEX_FILE="$dotest/patch-merge-tmp-index"'
 144
 145    if test -z "$GIT_QUIET"
 146    then
 147        eval "$cmd git diff-index --cached --diff-filter=AM --name-status HEAD"
 148    fi
 149
 150    cmd="$cmd git apply --cached $git_apply_opt"' <"$dotest/patch"'
 151    if eval "$cmd"
 152    then
 153        mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
 154        mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
 155    else
 156        cannot_fallback "$(gettext "Did you hand edit your patch?
 157It does not apply to blobs recorded in its index.")"
 158    fi
 159
 160    test -f "$dotest/patch-merge-index" &&
 161    his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
 162    orig_tree=$(cat "$dotest/patch-merge-base") &&
 163    rm -fr "$dotest"/patch-merge-* || exit 1
 164
 165    say "$(gettext "Falling back to patching base and 3-way merge...")"
 166
 167    # This is not so wrong.  Depending on which base we picked,
 168    # orig_tree may be wildly different from ours, but his_tree
 169    # has the same set of wildly different changes in parts the
 170    # patch did not touch, so recursive ends up canceling them,
 171    # saying that we reverted all those changes.
 172
 173    eval GITHEAD_$his_tree='"$FIRSTLINE"'
 174    export GITHEAD_$his_tree
 175    if test -n "$GIT_QUIET"
 176    then
 177            GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
 178    fi
 179    git-merge-recursive $orig_tree -- HEAD $his_tree || {
 180            git rerere $allow_rerere_autoupdate
 181            die "$(gettext "Failed to merge in the changes.")"
 182    }
 183    unset GITHEAD_$his_tree
 184}
 185
 186clean_abort () {
 187        test $# = 0 || echo >&2 "$@"
 188        rm -fr "$dotest"
 189        exit 1
 190}
 191
 192patch_format=
 193
 194check_patch_format () {
 195        # early return if patch_format was set from the command line
 196        if test -n "$patch_format"
 197        then
 198                return 0
 199        fi
 200
 201        # we default to mbox format if input is from stdin and for
 202        # directories
 203        if test $# = 0 || test "x$1" = "x-" || test -d "$1"
 204        then
 205                patch_format=mbox
 206                return 0
 207        fi
 208
 209        # otherwise, check the first few non-blank lines of the first
 210        # patch to try to detect its format
 211        {
 212                # Start from first line containing non-whitespace
 213                l1=
 214                while test -z "$l1"
 215                do
 216                        read l1 || break
 217                done
 218                read l2
 219                read l3
 220                case "$l1" in
 221                "From "* | "From: "*)
 222                        patch_format=mbox
 223                        ;;
 224                '# This series applies on GIT commit'*)
 225                        patch_format=stgit-series
 226                        ;;
 227                "# HG changeset patch")
 228                        patch_format=hg
 229                        ;;
 230                *)
 231                        # if the second line is empty and the third is
 232                        # a From, Author or Date entry, this is very
 233                        # likely an StGIT patch
 234                        case "$l2,$l3" in
 235                        ,"From: "* | ,"Author: "* | ,"Date: "*)
 236                                patch_format=stgit
 237                                ;;
 238                        *)
 239                                ;;
 240                        esac
 241                        ;;
 242                esac
 243                if test -z "$patch_format" &&
 244                        test -n "$l1" &&
 245                        test -n "$l2" &&
 246                        test -n "$l3"
 247                then
 248                        # This begins with three non-empty lines.  Is this a
 249                        # piece of e-mail a-la RFC2822?  Grab all the headers,
 250                        # discarding the indented remainder of folded lines,
 251                        # and see if it looks like that they all begin with the
 252                        # header field names...
 253                        tr -d '\015' <"$1" |
 254                        sed -n -e '/^$/q' -e '/^[       ]/d' -e p |
 255                        sane_egrep -v '^[!-9;-~]+:' >/dev/null ||
 256                        patch_format=mbox
 257                fi
 258        } < "$1" || clean_abort
 259}
 260
 261split_patches () {
 262        case "$patch_format" in
 263        mbox)
 264                if test t = "$keepcr"
 265                then
 266                    keep_cr=--keep-cr
 267                else
 268                    keep_cr=
 269                fi
 270                git mailsplit -d"$prec" -o"$dotest" -b $keep_cr -- "$@" > "$dotest/last" ||
 271                clean_abort
 272                ;;
 273        stgit-series)
 274                if test $# -ne 1
 275                then
 276                        clean_abort "$(gettext "Only one StGIT patch series can be applied at once")"
 277                fi
 278                series_dir=$(dirname "$1")
 279                series_file="$1"
 280                shift
 281                {
 282                        set x
 283                        while read filename
 284                        do
 285                                set "$@" "$series_dir/$filename"
 286                        done
 287                        # remove the safety x
 288                        shift
 289                        # remove the arg coming from the first-line comment
 290                        shift
 291                } < "$series_file" || clean_abort
 292                # set the patch format appropriately
 293                patch_format=stgit
 294                # now handle the actual StGIT patches
 295                split_patches "$@"
 296                ;;
 297        stgit)
 298                this=0
 299                for stgit in "$@"
 300                do
 301                        this=$(expr "$this" + 1)
 302                        msgnum=$(printf "%0${prec}d" $this)
 303                        # Perl version of StGIT parse_patch. The first nonemptyline
 304                        # not starting with Author, From or Date is the
 305                        # subject, and the body starts with the next nonempty
 306                        # line not starting with Author, From or Date
 307                        @@PERL@@ -ne 'BEGIN { $subject = 0 }
 308                                if ($subject > 1) { print ; }
 309                                elsif (/^\s+$/) { next ; }
 310                                elsif (/^Author:/) { s/Author/From/ ; print ;}
 311                                elsif (/^(From|Date)/) { print ; }
 312                                elsif ($subject) {
 313                                        $subject = 2 ;
 314                                        print "\n" ;
 315                                        print ;
 316                                } else {
 317                                        print "Subject: ", $_ ;
 318                                        $subject = 1;
 319                                }
 320                        ' < "$stgit" > "$dotest/$msgnum" || clean_abort
 321                done
 322                echo "$this" > "$dotest/last"
 323                this=
 324                msgnum=
 325                ;;
 326        hg)
 327                this=0
 328                for hg in "$@"
 329                do
 330                        this=$(( $this + 1 ))
 331                        msgnum=$(printf "%0${prec}d" $this)
 332                        # hg stores changeset metadata in #-commented lines preceding
 333                        # the commit message and diff(s). The only metadata we care about
 334                        # are the User and Date (Node ID and Parent are hashes which are
 335                        # only relevant to the hg repository and thus not useful to us)
 336                        # Since we cannot guarantee that the commit message is in
 337                        # git-friendly format, we put no Subject: line and just consume
 338                        # all of the message as the body
 339                        LANG=C LC_ALL=C @@PERL@@ -M'POSIX qw(strftime)' -ne 'BEGIN { $subject = 0 }
 340                                if ($subject) { print ; }
 341                                elsif (/^\# User /) { s/\# User/From:/ ; print ; }
 342                                elsif (/^\# Date /) {
 343                                        my ($hashsign, $str, $time, $tz) = split ;
 344                                        $tz = sprintf "%+05d", (0-$tz)/36;
 345                                        print "Date: " .
 346                                              strftime("%a, %d %b %Y %H:%M:%S ",
 347                                                       localtime($time))
 348                                              . "$tz\n";
 349                                } elsif (/^\# /) { next ; }
 350                                else {
 351                                        print "\n", $_ ;
 352                                        $subject = 1;
 353                                }
 354                        ' <"$hg" >"$dotest/$msgnum" || clean_abort
 355                done
 356                echo "$this" >"$dotest/last"
 357                this=
 358                msgnum=
 359                ;;
 360        *)
 361                if test -n "$patch_format"
 362                then
 363                        clean_abort "$(eval_gettext "Patch format \$patch_format is not supported.")"
 364                else
 365                        clean_abort "$(gettext "Patch format detection failed.")"
 366                fi
 367                ;;
 368        esac
 369}
 370
 371prec=4
 372dotest="$GIT_DIR/rebase-apply"
 373sign= utf8=t keep= keepcr= skip= interactive= resolved= rebasing= abort=
 374resolvemsg= resume= scissors= no_inbody_headers=
 375git_apply_opt=
 376committer_date_is_author_date=
 377ignore_date=
 378allow_rerere_autoupdate=
 379gpg_sign_opt=
 380
 381if test "$(git config --bool --get am.keepcr)" = true
 382then
 383    keepcr=t
 384fi
 385
 386while test $# != 0
 387do
 388        case "$1" in
 389        -i|--interactive)
 390                interactive=t ;;
 391        -b|--binary)
 392                gettextln >&2 "The -b/--binary option has been a no-op for long time, and
 393it will be removed. Please do not use it anymore."
 394                ;;
 395        -3|--3way)
 396                threeway=t ;;
 397        -s|--signoff)
 398                sign=t ;;
 399        -u|--utf8)
 400                utf8=t ;; # this is now default
 401        --no-utf8)
 402                utf8= ;;
 403        -k|--keep)
 404                keep=t ;;
 405        --keep-non-patch)
 406                keep=b ;;
 407        -c|--scissors)
 408                scissors=t ;;
 409        --no-scissors)
 410                scissors=f ;;
 411        -r|--resolved|--continue)
 412                resolved=t ;;
 413        --skip)
 414                skip=t ;;
 415        --abort)
 416                abort=t ;;
 417        --rebasing)
 418                rebasing=t threeway=t ;;
 419        --resolvemsg=*)
 420                resolvemsg="${1#--resolvemsg=}" ;;
 421        --whitespace=*|--directory=*|--exclude=*|--include=*)
 422                git_apply_opt="$git_apply_opt $(sq "$1")" ;;
 423        -C*|-p*)
 424                git_apply_opt="$git_apply_opt $(sq "$1")" ;;
 425        --patch-format=*)
 426                patch_format="${1#--patch-format=}" ;;
 427        --reject|--ignore-whitespace|--ignore-space-change)
 428                git_apply_opt="$git_apply_opt $1" ;;
 429        --committer-date-is-author-date)
 430                committer_date_is_author_date=t ;;
 431        --ignore-date)
 432                ignore_date=t ;;
 433        --rerere-autoupdate|--no-rerere-autoupdate)
 434                allow_rerere_autoupdate="$1" ;;
 435        -q|--quiet)
 436                GIT_QUIET=t ;;
 437        --keep-cr)
 438                keepcr=t ;;
 439        --no-keep-cr)
 440                keepcr=f ;;
 441        --gpg-sign)
 442                gpg_sign_opt=-S ;;
 443        --gpg-sign=*)
 444                gpg_sign_opt="-S${1#--gpg-sign=}" ;;
 445        --)
 446                shift; break ;;
 447        *)
 448                usage ;;
 449        esac
 450        shift
 451done
 452
 453# If the dotest directory exists, but we have finished applying all the
 454# patches in them, clear it out.
 455if test -d "$dotest" &&
 456   test -f "$dotest/last" &&
 457   test -f "$dotest/next" &&
 458   last=$(cat "$dotest/last") &&
 459   next=$(cat "$dotest/next") &&
 460   test $# != 0 &&
 461   test "$next" -gt "$last"
 462then
 463   rm -fr "$dotest"
 464fi
 465
 466if test -d "$dotest" && test -f "$dotest/last" && test -f "$dotest/next"
 467then
 468        case "$#,$skip$resolved$abort" in
 469        0,*t*)
 470                # Explicit resume command and we do not have file, so
 471                # we are happy.
 472                : ;;
 473        0,)
 474                # No file input but without resume parameters; catch
 475                # user error to feed us a patch from standard input
 476                # when there is already $dotest.  This is somewhat
 477                # unreliable -- stdin could be /dev/null for example
 478                # and the caller did not intend to feed us a patch but
 479                # wanted to continue unattended.
 480                test -t 0
 481                ;;
 482        *)
 483                false
 484                ;;
 485        esac ||
 486        die "$(eval_gettext "previous rebase directory \$dotest still exists but mbox given.")"
 487        resume=yes
 488
 489        case "$skip,$abort" in
 490        t,t)
 491                die "$(gettext "Please make up your mind. --skip or --abort?")"
 492                ;;
 493        t,)
 494                git rerere clear
 495                git read-tree --reset -u HEAD HEAD
 496                orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
 497                git reset HEAD
 498                git update-ref ORIG_HEAD $orig_head
 499                ;;
 500        ,t)
 501                if test -f "$dotest/rebasing"
 502                then
 503                        exec git rebase --abort
 504                fi
 505                git rerere clear
 506                if safe_to_abort
 507                then
 508                        git read-tree --reset -u HEAD ORIG_HEAD
 509                        git reset ORIG_HEAD
 510                fi
 511                rm -fr "$dotest"
 512                exit ;;
 513        esac
 514        rm -f "$dotest/dirtyindex"
 515else
 516        # Possible stray $dotest directory in the independent-run
 517        # case; in the --rebasing case, it is upto the caller
 518        # (git-rebase--am) to take care of stray directories.
 519        if test -d "$dotest" && test -z "$rebasing"
 520        then
 521                case "$skip,$resolved,$abort" in
 522                ,,t)
 523                        rm -fr "$dotest"
 524                        exit 0
 525                        ;;
 526                *)
 527                        die "$(eval_gettext "Stray \$dotest directory found.
 528Use \"git am --abort\" to remove it.")"
 529                        ;;
 530                esac
 531        fi
 532
 533        # Make sure we are not given --skip, --continue, or --abort
 534        test "$skip$resolved$abort" = "" ||
 535                die "$(gettext "Resolve operation not in progress, we are not resuming.")"
 536
 537        # Start afresh.
 538        mkdir -p "$dotest" || exit
 539
 540        if test -n "$prefix" && test $# != 0
 541        then
 542                first=t
 543                for arg
 544                do
 545                        test -n "$first" && {
 546                                set x
 547                                first=
 548                        }
 549                        if is_absolute_path "$arg"
 550                        then
 551                                set "$@" "$arg"
 552                        else
 553                                set "$@" "$prefix$arg"
 554                        fi
 555                done
 556                shift
 557        fi
 558
 559        check_patch_format "$@"
 560
 561        split_patches "$@"
 562
 563        # -i can and must be given when resuming; everything
 564        # else is kept
 565        echo " $git_apply_opt" >"$dotest/apply-opt"
 566        echo "$threeway" >"$dotest/threeway"
 567        echo "$sign" >"$dotest/sign"
 568        echo "$utf8" >"$dotest/utf8"
 569        echo "$keep" >"$dotest/keep"
 570        echo "$scissors" >"$dotest/scissors"
 571        echo "$no_inbody_headers" >"$dotest/no_inbody_headers"
 572        echo "$GIT_QUIET" >"$dotest/quiet"
 573        echo 1 >"$dotest/next"
 574        if test -n "$rebasing"
 575        then
 576                : >"$dotest/rebasing"
 577        else
 578                : >"$dotest/applying"
 579                if test -n "$HAS_HEAD"
 580                then
 581                        git update-ref ORIG_HEAD HEAD
 582                else
 583                        git update-ref -d ORIG_HEAD >/dev/null 2>&1
 584                fi
 585        fi
 586fi
 587
 588git update-index -q --refresh
 589
 590case "$resolved" in
 591'')
 592        case "$HAS_HEAD" in
 593        '')
 594                files=$(git ls-files) ;;
 595        ?*)
 596                files=$(git diff-index --cached --name-only HEAD --) ;;
 597        esac || exit
 598        if test "$files"
 599        then
 600                test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
 601                die "$(eval_gettext "Dirty index: cannot apply patches (dirty: \$files)")"
 602        fi
 603esac
 604
 605# Now, decide what command line options we will give to the git
 606# commands we invoke, based on the result of parsing command line
 607# options and previous invocation state stored in $dotest/ files.
 608
 609if test "$(cat "$dotest/utf8")" = t
 610then
 611        utf8=-u
 612else
 613        utf8=-n
 614fi
 615keep=$(cat "$dotest/keep")
 616case "$keep" in
 617t)
 618        keep=-k ;;
 619b)
 620        keep=-b ;;
 621*)
 622        keep= ;;
 623esac
 624case "$(cat "$dotest/scissors")" in
 625t)
 626        scissors=--scissors ;;
 627f)
 628        scissors=--no-scissors ;;
 629esac
 630if test "$(cat "$dotest/no_inbody_headers")" = t
 631then
 632        no_inbody_headers=--no-inbody-headers
 633else
 634        no_inbody_headers=
 635fi
 636if test "$(cat "$dotest/quiet")" = t
 637then
 638        GIT_QUIET=t
 639fi
 640if test "$(cat "$dotest/threeway")" = t
 641then
 642        threeway=t
 643fi
 644git_apply_opt=$(cat "$dotest/apply-opt")
 645if test "$(cat "$dotest/sign")" = t
 646then
 647        SIGNOFF=$(git var GIT_COMMITTER_IDENT | sed -e '
 648                        s/>.*/>/
 649                        s/^/Signed-off-by: /'
 650                )
 651else
 652        SIGNOFF=
 653fi
 654
 655last=$(cat "$dotest/last")
 656this=$(cat "$dotest/next")
 657if test "$skip" = t
 658then
 659        this=$(expr "$this" + 1)
 660        resume=
 661fi
 662
 663while test "$this" -le "$last"
 664do
 665        msgnum=$(printf "%0${prec}d" $this)
 666        next=$(expr "$this" + 1)
 667        test -f "$dotest/$msgnum" || {
 668                resume=
 669                go_next
 670                continue
 671        }
 672
 673        # If we are not resuming, parse and extract the patch information
 674        # into separate files:
 675        #  - info records the authorship and title
 676        #  - msg is the rest of commit log message
 677        #  - patch is the patch body.
 678        #
 679        # When we are resuming, these files are either already prepared
 680        # by the user, or the user can tell us to do so by --continue flag.
 681        case "$resume" in
 682        '')
 683                if test -f "$dotest/rebasing"
 684                then
 685                        commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
 686                                -e q "$dotest/$msgnum") &&
 687                        test "$(git cat-file -t "$commit")" = commit ||
 688                                stop_here $this
 689                        git cat-file commit "$commit" |
 690                        sed -e '1,/^$/d' >"$dotest/msg-clean"
 691                        echo "$commit" >"$dotest/original-commit"
 692                        get_author_ident_from_commit "$commit" >"$dotest/author-script"
 693                        git diff-tree --root --binary --full-index "$commit" >"$dotest/patch"
 694                else
 695                        git mailinfo $keep $no_inbody_headers $scissors $utf8 "$dotest/msg" "$dotest/patch" \
 696                                <"$dotest/$msgnum" >"$dotest/info" ||
 697                                stop_here $this
 698
 699                        # skip pine's internal folder data
 700                        sane_grep '^Author: Mail System Internal Data$' \
 701                                <"$dotest"/info >/dev/null &&
 702                                go_next && continue
 703
 704                        test -s "$dotest/patch" || {
 705                                eval_gettextln "Patch is empty.  Was it split wrong?
 706If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
 707To restore the original branch and stop patching run \"\$cmdline --abort\"."
 708                                stop_here $this
 709                        }
 710                        rm -f "$dotest/original-commit" "$dotest/author-script"
 711                        {
 712                                sed -n '/^Subject/ s/Subject: //p' "$dotest/info"
 713                                echo
 714                                cat "$dotest/msg"
 715                        } |
 716                        git stripspace > "$dotest/msg-clean"
 717                fi
 718                ;;
 719        esac
 720
 721        if test -f "$dotest/author-script"
 722        then
 723                eval $(cat "$dotest/author-script")
 724        else
 725                GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
 726                GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
 727                GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
 728        fi
 729
 730        if test -z "$GIT_AUTHOR_EMAIL"
 731        then
 732                gettextln "Patch does not have a valid e-mail address."
 733                stop_here $this
 734        fi
 735
 736        export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
 737
 738        case "$resume" in
 739        '')
 740            if test '' != "$SIGNOFF"
 741            then
 742                LAST_SIGNED_OFF_BY=$(
 743                    sed -ne '/^Signed-off-by: /p' \
 744                    "$dotest/msg-clean" |
 745                    sed -ne '$p'
 746                )
 747                ADD_SIGNOFF=$(
 748                    test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
 749                    test '' = "$LAST_SIGNED_OFF_BY" && echo
 750                    echo "$SIGNOFF"
 751                })
 752            else
 753                ADD_SIGNOFF=
 754            fi
 755            {
 756                if test -s "$dotest/msg-clean"
 757                then
 758                        cat "$dotest/msg-clean"
 759                fi
 760                if test '' != "$ADD_SIGNOFF"
 761                then
 762                        echo "$ADD_SIGNOFF"
 763                fi
 764            } >"$dotest/final-commit"
 765            ;;
 766        *)
 767                case "$resolved$interactive" in
 768                tt)
 769                        # This is used only for interactive view option.
 770                        git diff-index -p --cached HEAD -- >"$dotest/patch"
 771                        ;;
 772                esac
 773        esac
 774
 775        resume=
 776        if test "$interactive" = t
 777        then
 778            test -t 0 ||
 779            die "$(gettext "cannot be interactive without stdin connected to a terminal.")"
 780            action=again
 781            while test "$action" = again
 782            do
 783                gettextln "Commit Body is:"
 784                echo "--------------------------"
 785                cat "$dotest/final-commit"
 786                echo "--------------------------"
 787                # TRANSLATORS: Make sure to include [y], [n], [e], [v] and [a]
 788                # in your translation. The program will only accept English
 789                # input at this point.
 790                gettext "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
 791                read reply
 792                case "$reply" in
 793                [yY]*) action=yes ;;
 794                [aA]*) action=yes interactive= ;;
 795                [nN]*) action=skip ;;
 796                [eE]*) git_editor "$dotest/final-commit"
 797                       action=again ;;
 798                [vV]*) action=again
 799                       git_pager "$dotest/patch" ;;
 800                *)     action=again ;;
 801                esac
 802            done
 803        else
 804            action=yes
 805        fi
 806
 807        if test $action = skip
 808        then
 809                go_next
 810                continue
 811        fi
 812
 813        if test -x "$GIT_DIR"/hooks/applypatch-msg
 814        then
 815                "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
 816                stop_here $this
 817        fi
 818
 819        if test -f "$dotest/final-commit"
 820        then
 821                FIRSTLINE=$(sed 1q "$dotest/final-commit")
 822        else
 823                FIRSTLINE=""
 824        fi
 825
 826        say "$(eval_gettext "Applying: \$FIRSTLINE")"
 827
 828        case "$resolved" in
 829        '')
 830                # When we are allowed to fall back to 3-way later, don't give
 831                # false errors during the initial attempt.
 832                squelch=
 833                if test "$threeway" = t
 834                then
 835                        squelch='>/dev/null 2>&1 '
 836                fi
 837                eval "git apply $squelch$git_apply_opt"' --index "$dotest/patch"'
 838                apply_status=$?
 839                ;;
 840        t)
 841                # Resolved means the user did all the hard work, and
 842                # we do not have to do any patch application.  Just
 843                # trust what the user has in the index file and the
 844                # working tree.
 845                resolved=
 846                git diff-index --quiet --cached HEAD -- && {
 847                        gettextln "No changes - did you forget to use 'git add'?
 848If there is nothing left to stage, chances are that something else
 849already introduced the same changes; you might want to skip this patch."
 850                        stop_here_user_resolve $this
 851                }
 852                unmerged=$(git ls-files -u)
 853                if test -n "$unmerged"
 854                then
 855                        gettextln "You still have unmerged paths in your index
 856did you forget to use 'git add'?"
 857                        stop_here_user_resolve $this
 858                fi
 859                apply_status=0
 860                git rerere
 861                ;;
 862        esac
 863
 864        if test $apply_status != 0 && test "$threeway" = t
 865        then
 866                if (fall_back_3way)
 867                then
 868                    # Applying the patch to an earlier tree and merging the
 869                    # result may have produced the same tree as ours.
 870                    git diff-index --quiet --cached HEAD -- && {
 871                        say "$(gettext "No changes -- Patch already applied.")"
 872                        go_next
 873                        continue
 874                    }
 875                    # clear apply_status -- we have successfully merged.
 876                    apply_status=0
 877                fi
 878        fi
 879        if test $apply_status != 0
 880        then
 881                eval_gettextln 'Patch failed at $msgnum $FIRSTLINE'
 882                if test "$(git config --bool advice.amworkdir)" != false
 883                then
 884                        eval_gettextln 'The copy of the patch that failed is found in:
 885   $dotest/patch'
 886                fi
 887                stop_here_user_resolve $this
 888        fi
 889
 890        if test -x "$GIT_DIR"/hooks/pre-applypatch
 891        then
 892                "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
 893        fi
 894
 895        tree=$(git write-tree) &&
 896        commit=$(
 897                if test -n "$ignore_date"
 898                then
 899                        GIT_AUTHOR_DATE=
 900                fi
 901                parent=$(git rev-parse --verify -q HEAD) ||
 902                say >&2 "$(gettext "applying to an empty history")"
 903
 904                if test -n "$committer_date_is_author_date"
 905                then
 906                        GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
 907                        export GIT_COMMITTER_DATE
 908                fi &&
 909                git commit-tree ${parent:+-p} $parent ${gpg_sign_opt:+"$gpg_sign_opt"} $tree  \
 910                        <"$dotest/final-commit"
 911        ) &&
 912        git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
 913        stop_here $this
 914
 915        if test -f "$dotest/original-commit"; then
 916                echo "$(cat "$dotest/original-commit") $commit" >> "$dotest/rewritten"
 917        fi
 918
 919        if test -x "$GIT_DIR"/hooks/post-applypatch
 920        then
 921                "$GIT_DIR"/hooks/post-applypatch
 922        fi
 923
 924        go_next
 925done
 926
 927if test -s "$dotest"/rewritten; then
 928    git notes copy --for-rewrite=rebase < "$dotest"/rewritten
 929    if test -x "$GIT_DIR"/hooks/post-rewrite; then
 930        "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten
 931    fi
 932fi
 933
 934# If am was called with --rebasing (from git-rebase--am), it's up to
 935# the caller to take care of housekeeping.
 936if ! test -f "$dotest/rebasing"
 937then
 938        rm -fr "$dotest"
 939        git gc --auto
 940fi